*** bcas.c.orig	2011-05-19 01:22:28.000000000 +0900
--- bcas.c	2012-08-04 17:21:55.558189838 +0900
***************
*** 396,401 ****
--- 396,409 ----
        retcode != CARD_RETCODE_GD_PREPPV &&
        retcode != CARD_RETCODE_GD_POSTPPV &&
        retcode != CARD_RETCODE_PV_PREPPV && retcode != CARD_RETCODE_PV_POSTPPV) {
+     if (retcode == 0xa103 ||
+         (retcode >= 0x8901 &&  retcode <= 0x8903) ||
+         (retcode >= 0x8501 &&  retcode <= 0x8503) ||
+         (retcode >= 0x8301 &&  retcode <= 0x8303)) {
+       syslog (LOG_NOTICE,
+           "Ret code[0x%04x] in a ECM response.\n", retcode);
+       goto through;
+     }
      syslog (LOG_NOTICE,
          "Bad ret code[0x%04x] in a ECM response.\n", retcode);
      goto failed;
***************
*** 430,435 ****
--- 438,449 ----
    }
    pthread_mutex_unlock (&card->lock);
    return;
+ 
+ through:
+   pthread_mutex_lock (&card->lock);
+   kinfo->status = CMD_S_FAILED;
+   pthread_mutex_unlock (&card->lock);
+   return;
  }
  
  
